/**
 * dt-helper.js
 * 
 * JS helpers for datatables
 * 
 */
var obj = null;

var button;
var uid;
var rowid;
var linkrefid;
var _delete;
var _delete_text;

$(document).ready(function() {
    activateDatatables();
    
    $('#modalConfirm').on('show.bs.modal', function (event) {
      button = $(event.relatedTarget);      // Button that triggered the modal
      uid = button.data('uid');             // Extract info from data-* attributes
      uidlist = $('[data-uidlist]').attr('data-uidlist');
      rowid = button.data('rowid'); 
      linkrefid = button.data('linkrefid');
      _delete = $("._delete").attr('delete');
      _delete_text = $("._delete_text").attr('delete_text');
      
      var $modal = $(this)
      $modal.find('.modal-title').text(_delete + '?');
      $modal.find('.modal-body').html(_delete_text.replace('%s', uid));
      
      if (! uid && typeof(uidlist) != 'undefined') {
          $modal.find('.modal-body').html(_delete_text.replace('%s', uidlist));
      }
      
      $('#modalConfirm').attr('uid', uid);
      $('#modalConfirm').attr('rowid', rowid);
      $('#modalConfirm').attr('linkrefid', linkrefid);
    });

    $('#modalConfirm').click(function() {
        var id = $(document.activeElement).attr('id'); 
        var $modalConfirm = $('#modalConfirm');
        if (id == 'button-modalConfirm') {
            linkrefid = $modalConfirm.attr('linkrefid');
            rowid = $modalConfirm.attr('rowid');
            uid = $modalConfirm.attr('uid');
            uidlist = $('[data-uidlist]').attr('data-uidlist');

            href = $('#' + linkrefid).attr('href');
            if (typeof(uidlist) != 'undefined') {
//                $modal.find('.modal-body').html(_delete_text.replace('%s', uidlist));
                href = href.replace('UIDLIST', uidlist);
            }
            // call url to delete record and fade out
            // TODO: at the moment the record will be faded out no matter what result is returned.
            $.get( href );
            if (typeof(uidlist) != 'undefined') {
                params = rowid.split('_');
                uidlistarray = uidlist.split(',');
                for (i=0; i < uidlistarray.length; i++) {
                    rowid = params[0] + '_' + uidlistarray[i];
                    $('#' +  rowid).fadeOut();
                }
                $('.tx_datatables-bulkDelete').prop('checked', false);
            } else {
                $('#' +  rowid).fadeOut();
            }
        }
    });
});

/**
 * disable sorting of last column in table view
*/
function activateDatatables() {
    var columnCount = 0;
    var cObjUid = '';
    var ajaxUrl = '';
    var dontsort = [];
    var addclass = [];
    var myId = '';
    $('.tx_datatables-datatable').each(function(){
        $datatable = $(this);
        
        // count th-elements to get number of columns
        columnCount = $datatable.find('thead tr th').length - 1;
        
        // get cObjUid (id of content element) from attribute
        cObjUid = parseInt($datatable.attr('cobjuid'));
        
        // create url for list action
        // TODO: make ajax id configurable in backend
        ajaxUrl = 
            $("._baseUrl").attr('baseurl') +
            'index.php?cobj=' + cObjUid +
            '&type=' + $("._ajaxCallId").attr('ajaxcallid') + 
            '&tx_datatables_datatable[action]=list&tx_datatables_datatable[controller]=Datatable'+
            '&L=' + getUrlParam('L') +
            '&id=' + getUrlParam('id')
            ;

        // create array for columns not be sorted indicated by attribute dtdontsort
        dontsort = [];
        addclass = [];
        for(var i=0;i<=columnCount;i++) {
            addclass.push();
            if ($datatable.find('thead tr th:eq('+i+')').attr('dtdontsort') == "1") {
                dontsort.push(i);
            }
        }

        // invoke datatables
        var table = $datatable.DataTable({
            "language": {
              "url": "/typo3conf/ext/datatables/Resources/Public/Scripts/datatables." + $('html').attr('lang') + ".json"  
            },
            "bProcessing": true,
            "ajax": ajaxUrl,
            "serverSide": true,
            "fnRowCallback": function( nRow, aData, iDisplayIndex ) {
                var c = $(this).closest('table.dataTable').find('thead tr th').length - 1;
                for(var i=0;i<=c;i++) {
                    $('> td:eq('+i+')', nRow).addClass( $(this).closest('table.dataTable').find('thead tr th:eq('+i+')').attr('dtclass') );
                    $('> td:eq('+i+')', nRow).addClass( $(this).closest('table.dataTable').find('thead tr th:eq('+i+')').attr('dtalign') );
              }
              return nRow;
            },
            "fnDrawCallback": function() { callbackFn()},
            "responsive" : true,
            "lengthMenu": [[10, 20, 50, 100, 200], [10, 20, 50, 100, 200]],
            "stateSave": true,
            /*
            "dom": 'Blfrtip',
            "buttons": [
                {
                    text: 'Reload table',
                    action: function () {
                        $(this).closest('.dataTables_wrapper').find('.dataTable').DataTable().draw();
                    }
                }
            ],
            */
           
            // apply the dontsort array
            "columnDefs": [
                {"targets": dontsort, "orderable": false, "searchable": false}
            ]
        });
            
        // bulkdelete checks    
        $datatable.find(".tx_datatables-bulkDelete").on('click',function() { // bulk checked
            var status = this.checked;
            $datatable.find(".tx_datatables-deleteRow").each( function() {
                $(this).prop("checked",status);
            });
        });      
    });
}

/**
 * callbackFn
 * 
 * if the attribute autoAjax is set in a tag with class _autoAjax attached the autoAjax feature will be in voked
 * 
 * @returns {undefined}
 */
function callbackFn () {
    if ($("._autoAjax").attr('autoAjax') == '1') {
        autoAjax();
    }
    
    $('[dt-mode="dt-bubbleup-td"]').each(function(){
        $(this).closest('td').addClass($(this).attr('class'));
        $(this).parent().html($(this).html());
    });

    $('[dt-mode="dt-bubbleup-tr"]').each(function(){
        $(this).closest('tr').addClass($(this).attr('class'));
        $(this).parent().html($(this).html());
    });
    
}

/**
 * 
 * @returns {undefined}
 */
function getSelectedRecords ( context ) {
    if ( $('.tx_datatables-deleteRow:checked', context).length > 0 ){  // at-least one checkbox checked
        var ids = [];
        $('.tx_datatables-deleteRow').each(function(){
            if($(this).is(':checked')) { 
                ids.push($(this).val());
            }
        });
        return ids.toString(); 
    }
}


function getUrlParam( sParam ) {
    var sPageURL = window.location.search.substring(1);
    var sURLVariables = sPageURL.split('&');
    for (var i = 0; i < sURLVariables.length; i++) {
        var sParameterName = sURLVariables[i].split('=');
        if (sParameterName[0] === sParam) {
            return sParameterName[1];
        }
    }
    return '';
}

/**
 * function makeInt
 * 
 * @param {type} value
 * @returns {unresolved}
 */
function makeInt ( value ) {
	if (typeof(value) == 'undefined') {
		return null;
	} else if (value == '') {
		return null;
	} else {
		return parseInt(value);
	}
}

